<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { onMounted, ref, inject, computed } from 'vue'
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import { useRoute, useRouter } from 'vue-router';
import * as jose from 'jose';
import { useAccountStore } from '@/stores/account';
import Input from '@/components/general/form/Input.vue';
import { request } from '@/lib/request';
import { getCookie, setCookie } from '@/lib/utils';
import CreateAccountModal from '@/components/account/CreateAccountModal.vue';
import PasswordResetRequestModal from '@/components/account/PasswordResetRequestModal.vue';
import Button from '@/components/general/Button.vue';
import { Dialog, DialogPanel } from '@headlessui/vue';

const { t } = useI18n();
const $t = t;

const router = useRouter();
const route = useRoute();
const store = useAccountStore();
const { mail, accesscode, canUseAI } = storeToRefs(store);
const actionURL = ref('');
const id = ref('');
const type = ref('administration');
const showError = ref(false);
let configuration = inject<any>('configuration');
const errorText = ref('');
const showErrorBox = ref(false);

const getBasePath = configuration.basePath;
const getApiServer = configuration.apiServer;
const showWinterTheme = configuration.winterTheme;

const redirectToUsersPage = () => {
    router.push({ name: 'users', params: { id: id.value.toString().toLowerCase() } });
};

const setUserType = (value: string) => { type.value = value; };

const toggleInfoLogin = () => {
    showErrorAccordion.value = !showErrorAccordion.value;
    showInfoAccordion.value = !showInfoAccordion.value;
    showLoginAccordion.value = !showLoginAccordion.value;
};

const checkStatus = () => {
    fetch(getApiServer + '/api/stats/status').then(response => {
        if (response.status !== 200) {
            showError.value = true;
            showErrorBox.value = true;
            toggleInfoLogin()
        }
    }).catch(err => {
        showError.value = true;
        showErrorBox.value = true;
        toggleInfoLogin()
    })
};

const create = () => {
    let title = $t("indexPage.pageTitle");
    document.title = title;
    checkStatus();
};
create();
onMounted(() => {
    let title = $t("indexPage.pageTitle");
    document.title = title;
});

const loginMail = ref('');
const password = ref('');
const showPasswordField = ref(false);

const checkMail = async () => {
    let response = await request('POST', getApiServer + '/api/account/checkmail', { mail: loginMail.value.toLocaleLowerCase() });
    if (response && response.success) {
        showPasswordField.value = true;
    } else {
        showAccountCreateModal(true);
    }
}

const reEnterMail = () => {
    showPasswordField.value = false;
}

const isAccountCreateModalOpen = ref(false);
const showAccountCreateModal = (value: boolean, showRegister?: boolean) => {
    isAccountCreateModalOpen.value = value;
    if (showRegister) goToCreate();
}

const login = async () => {
    //error.value = '';
    let response = await request('POST', getApiServer + '/api/account/login', { password: password.value, mail: loginMail.value.toLocaleLowerCase() });
    if (response && response.success && response.token) {
        setCookie(response.token, getBasePath);
        mail.value = loginMail.value;
        const payload = jose.UnsecuredJWT.decode(response.token);
        accesscode.value = String(payload.payload.accesscode);
        canUseAI.value = Boolean(payload.payload.canUseAI);

        router.push({ name: "overview-account" });
    } else {
        errorText.value = $t('general.variables.password.error');
    }
}

const isPasswordResetModalOpen = ref(false);
const showPasswordRequestModal = (value: boolean) => {
    isPasswordResetModalOpen.value = value;
}

const goToCreate = () => {
    router.push({ name: "registration" });
}

const showErrorAccordion = ref(false);
const showInfoAccordion = ref(true);
const showLoginAccordion = ref(false);

const handleCloseModal = () => {
    let path = { name: "home" };
    if (getCookie('Token') !== undefined) {
        path = { name: 'overview-account' };
    }
    router.push(path);
}

</script>
<template>
    <div class="bg-gray-100 h-screen">
        <nav class="flex flex-row bg-accent1-default h-10 max-h-10"></nav>
        <div class="bg-right-bottom bg-no-repeat md:mx-10 my-10 h-[calc(100vh-160px)]"
            :style="{ backgroundImage: 'url(' + getBasePath + 'images/home_logo.png)' }">
            <div class="flex max-w-xl mx-auto my-auto md:px-4 h-full items-center">
                <div class="mx-auto">
                    <div>
                        <div class="relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md mb-4 border border-red-500 w-96"
                            :style="{ opacity: (showError ? 1 : 0) }" v-if="showError">
                            <div class="p-4">
                                <div class="p-4" @click="toggleInfoLogin">
                                    <h4 class="text-red-500 text-2xl flex flex-row gap-2">
                                        <i class="ri-information-2-line"></i>
                                        <span>{{ $t("indexPage.error.header") }}</span>
                                    </h4>
                                </div>
                                <transition name="expand">
                                    <div class="p-4 pt-0 text-gray-500 break-word" v-if="showErrorAccordion">
                                        <div class="pt-3"
                                            v-html="'<strong>' + $t('indexPage.error.connection') + '</strong>'"></div>
                                    </div>
                                </transition>
                            </div>
                        </div>

                        <div class="relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md mb-4 border-blue-900 border w-96"
                            v-if='$t("indexPage.updateText.preUpdate").length > 0 || $t("indexPage.updateText.afterUpdate").length > 0'>
                            <div class="p-4">
                                <div class="p-4" @click="toggleInfoLogin">
                                    <h4 class="border-blue-900 text-2xl flex flex-row gap-2">
                                        <i class="ri-information-2-line"></i>
                                        <span>{{ $t("indexPage.updateText.header") }}</span>
                                    </h4>
                                </div>
                                <transition name="expand">
                                    <div class="p-4 pt-0 text-gray-500 break-word" v-if="showInfoAccordion"
                                        ref="innerContent">
                                        <!--<span v-html='$t("indexPage.updateText.preUpdate") || $t("indexPage.updateText.afterUpdate")'></span>-->
                                        <div class="pt-0"
                                            v-html='$t("indexPage.updateText.preUpdate") || $t("indexPage.updateText.afterUpdate")'>
                                        </div>

                                    </div>
                                </transition>
                            </div>
                        </div>

                        <div
                            class="relative box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md w-96">
                            <div class="p-4 flex flex-col gap-5">
                                <h3 class="text-xl text-center">{{ $t("indexPage.pageName") }}</h3>
                                <div v-if="errorText">
                                    <div class="my-4 w-80">
                                        <strong class="text-red-700">{{ errorText }}</strong>
                                    </div>
                                </div>
                                <Button variant="accent1" @click="goToCreate">{{ $t('general.variables.account.sg') + ' ' + $t('general.variables.create') }}</Button>
                                <div v-if="!showErrorBox">
                                    <Button variant="white" @click="toggleInfoLogin">{{
                                        $t("indexPage.buttonTexts.login.header") }}</Button>
                                    <transition name="expand-login">
                                        <div class="pb-0" v-if="showLoginAccordion">
                                            <div>
                                                <div class="flex flex-row my-2 w-full">
                                                    <div class="w-1/2 rounded-t-lg h-12 hover:bg-gray-200 cursor-pointer border-b-4 border-gray-300 rounded-b-sm"
                                                        :class="{ 'border-b-4 border-gray-600 rounded-b-sm bg-gray-100': type !== null && type == 'administration' }"
                                                        @click="setUserType('administration')">
                                                        <p
                                                            class="align-middle text-lg leading-[48px] pl-4 text-gray-700">
                                                            {{ $t("indexPage.buttonTexts.login.tabs.admin") }}</p>
                                                    </div>
                                                    <div class="w-1/2 rounded-t-lg h-12 hover:bg-gray-200 cursor-pointer border-b-4 border-gray-300 rounded-b-sm"
                                                        :class="{ 'border-b-4 border-gray-600 rounded-b-sm bg-gray-100': type !== null && type == 'user' }"
                                                        @click="setUserType('user')">
                                                        <p
                                                            class="align-middle text-lg leading-[48px] pl-4 text-gray-700">
                                                            {{ $t("indexPage.buttonTexts.login.tabs.user") }}</p>
                                                    </div>
                                                </div>
                                                <fieldset class="w-full">
                                                    <div v-if="type !== null && type == 'user'">
                                                        <Input v-model="id" :required="true" icon="home-2" type="text"
                                                            size="w-full"
                                                            :placeholder="$t('indexPage.buttonTexts.login.input')" />
                                                        <div class="mt-2">
                                                            <Button variant="confirm"
                                                                @click.stop.prevent="redirectToUsersPage"
                                                                v-if="id.length > 0">{{
                                                                    $t("indexPage.buttonTexts.login.submit") }}</Button>
                                                            <Button variant="disabled" v-else>{{
                                                                $t("indexPage.buttonTexts.login.submit") }}</Button>
                                                        </div>
                                                    </div>
                                                    <div class="w-full"
                                                        v-else-if="type !== null && type == 'administration'">
                                                        <div>
                                                            <Transition name="slide-fade" mode="out-in">
                                                                <form @submit.prevent="">
                                                                    <Input id="user-text-field" class="mb-2"
                                                                        v-model="loginMail" type="email" size="w-full"
                                                                        :placeholder="$t('placeholder.mail')"
                                                                        icon="mail" @keyup.enter="checkMail"
                                                                        autocomplete="username"
                                                                        v-show="!showPasswordField" :autofocus="true" />
                                                                    <div class="flex flex-col gap-1"
                                                                        v-show="showPasswordField">
                                                                        <p class="flex flex-row gap-1"><span
                                                                                class="text-xs">{{ loginMail
                                                                                }}</span>
                                                                            <Tooltip
                                                                                :tooltip="$t('general.variables.change')">
                                                                                <div class="cursor-pointer hover:bg-gray-100 rounded-full size-4 p-1"
                                                                                    @click.stop.prevent="reEnterMail"><i
                                                                                        class="ri-pencil-line absolute -mt-1.5 -ml-0.5"></i>
                                                                                </div>
                                                                            </Tooltip>
                                                                        </p>
                                                                        <Input id="password-text-field"
                                                                            v-model="password" type="password"
                                                                            size="w-full"
                                                                            :placeholder="$t('general.variables.password.sg')"
                                                                            icon="key" autocomplete="current-password"
                                                                            @keyup.enter="login" />
                                                                    </div>
                                                                </form>
                                                            </Transition>
                                                        </div>
                                                        <div class="w-full mb-2">
                                                            <Button variant="confirm" @click.stop.prevent="checkMail"
                                                                v-if="loginMail.length > 0 && !showPasswordField">{{
                                                                    $t("general.buttons.next")
                                                                }}</Button>
                                                            <Button variant="disabled" v-else-if="!showPasswordField">{{
                                                                $t("general.buttons.next")
                                                            }}</Button>
                                                            <Button variant="confirm" @click.stop.prevent="login"
                                                                v-if="showPasswordField && password.length >= 8">{{
                                                                    $t("general.buttons.next")
                                                                }}</Button>
                                                            <Button variant="disabled" v-else-if="showPasswordField">{{
                                                                $t("general.buttons.next")
                                                            }}</Button>
                                                        </div>
                                                        <a class="text-center w-full block cursor-pointer"
                                                            @click="showPasswordRequestModal(true)">{{
                                                                $t("adminMenu.passwordReset.label") }}
                                                        </a>
                                                    </div>
                                                </fieldset>
                                            </div>
                                        </div>
                                    </transition>
                                </div>
                                <Button variant="accent2" :to="$t('indexPage.buttonTexts.help.url')">{{
                                    $t("indexPage.buttonTexts.help.label") }}</Button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <RouterView v-slot="{ Component }">
                <Dialog :open="Component !== undefined" @close="handleCloseModal">
                    <div class="fixed inset-0 bg-black/30" aria-hidden="true"></div>
                    <div class="fixed inset-0 flex w-screen items-center justify-center z-[100]">
                        <DialogPanel
                            class="w-full rounded-lg bg-white max-w-screen md:max-w-3xl overflow-auto max-h-screen md:max-h-[calc(80dvh)]">
                            <component :is="Component" />
                        </DialogPanel>
                    </div>
                </Dialog>

            </RouterView>
        </div>
        <div class="h-10 max-h-10 w-full text-center bg-accent1-default p-3 text-accent1-text select-none">
            <span class="mx-auto">
                <a class="hover:text-gray-300 hover:no-underline" :href="getBasePath + 'impress'" target="_self"
                    rel="noopener"> {{
                        $t("indexPage.impress") }}</a>
                <span class="mx-4">|</span>
                <a class="hover:text-gray-300 hover:no-underline" :href="getBasePath + 'privacy'" target="_self"
                    rel="noopener"> {{
                        $t("indexPage.privacy") }} </a>
            </span>
            <div v-if="showWinterTheme">
                <div class="snowflakes" aria-hidden="true">
                    <div class="snowflake">❆</div>
                    <div class="snowflake">❅</div>
                    <div class="snowflake">❆</div>
                    <div class="snowflake">❅</div>
                    <div class="snowflake">❆</div>
                    <div class="snowflake">❅</div>
                    <div class="snowflake">❆</div>
                    <div class="snowflake">❅</div>
                    <div class="snowflake">❆</div>
                    <div class="snowflake">❅</div>
                    <div class="snowflake">❆</div>
                </div>
            </div>
        </div>
        <CreateAccountModal v-if="isAccountCreateModalOpen" @close="(value) => showAccountCreateModal(false, value)" />
        <PasswordResetRequestModal v-if="isPasswordResetModalOpen" @close="showPasswordRequestModal(false)" />
    </div>
</template>
<style scoped>
.top-bar {
    min-height: 40px !important;
    max-height: 40px !important;
}

.account-entry {
    color: white !important;
    max-height: 40px;
    min-height: 40px;
}

.account-entry:hover {
    color: #CCCCCC !important;
}

.account-entry>span {
    border-bottom: 1px solid white;
    padding-bottom: 4px;
}

.account-entry:hover>span {
    border-bottom-color: #CCCCCC !important;
}

.text-xsmall {
    font-size: 12px;
    vertical-align: bottom;
}

.slide-fade-enter-active {
    transition: all 0.3s ease-out;
}

.slide-fadel-leave-active {
    transition: all 0.1s cubic-bezier(1, 0.5, 0.8, 1);
}

.slide-fade-enter-from,
.slide-fade-leave-to {
    transform: translateX(20px);
    opacity: 0;
}

.snowflake {
    color: #fff;
    font-size: 1.4em;
    font-family: Arial, sans-serif;
    text-shadow: 0 0 5px #003064;
}

@-webkit-keyframes snowflakes-fall {
    0% {
        top: -10%
    }

    100% {
        top: 100%
    }
}

@-webkit-keyframes snowflakes-shake {

    0%,
    100% {
        -webkit-transform: translateX(0);
        transform: translateX(0)
    }

    50% {
        -webkit-transform: translateX(80px);
        transform: translateX(80px)
    }
}

@keyframes snowflakes-fall {
    0% {
        top: -10%
    }

    100% {
        top: 100%
    }
}

@keyframes snowflakes-shake {

    0%,
    100% {
        transform: translateX(0)
    }

    50% {
        transform: translateX(80px)
    }
}

.snowflake {
    position: fixed;
    top: -10%;
    z-index: 9999;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    cursor: default;
    -webkit-animation-name: snowflakes-fall, snowflakes-shake;
    -webkit-animation-duration: 10s, 3s;
    -webkit-animation-timing-function: linear, ease-in-out;
    -webkit-animation-iteration-count: infinite, infinite;
    -webkit-animation-play-state: running, running;
    animation-name: snowflakes-fall, snowflakes-shake;
    animation-duration: 10s, 3s;
    animation-timing-function: linear, ease-in-out;
    animation-iteration-count: infinite, infinite;
    animation-play-state: running, running
}

.snowflake:nth-of-type(0) {
    left: 1%;
    -webkit-animation-delay: 0s, 0s;
    animation-delay: 0s, 0s
}

.snowflake:nth-of-type(1) {
    left: 10%;
    -webkit-animation-delay: 1s, 1s;
    animation-delay: 1s, 1s
}

.snowflake:nth-of-type(2) {
    left: 20%;
    -webkit-animation-delay: 6s, .5s;
    animation-delay: 6s, .5s
}

.snowflake:nth-of-type(3) {
    left: 30%;
    -webkit-animation-delay: 4s, 2s;
    animation-delay: 4s, 2s
}

.snowflake:nth-of-type(4) {
    left: 40%;
    -webkit-animation-delay: 2s, 2s;
    animation-delay: 2s, 2s
}

.snowflake:nth-of-type(5) {
    left: 50%;
    -webkit-animation-delay: 8s, 3s;
    animation-delay: 8s, 3s
}

.snowflake:nth-of-type(6) {
    left: 60%;
    -webkit-animation-delay: 6s, 2s;
    animation-delay: 6s, 2s
}

.snowflake:nth-of-type(7) {
    left: 70%;
    -webkit-animation-delay: 2.5s, 1s;
    animation-delay: 2.5s, 1s
}

.snowflake:nth-of-type(8) {
    left: 80%;
    -webkit-animation-delay: 1s, 0s;
    animation-delay: 1s, 0s
}

.snowflake:nth-of-type(9) {
    left: 90%;
    -webkit-animation-delay: 3s, 1.5s;
    animation-delay: 3s, 1.5s
}

.snowflake:nth-of-type(10) {
    left: 25%;
    -webkit-animation-delay: 2s, 0s;
    animation-delay: 2s, 0s
}

.snowflake:nth-of-type(11) {
    left: 65%;
    -webkit-animation-delay: 4s, 2.5s;
    animation-delay: 4s, 2.5s
}

.expand-enter-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
    padding-bottom: 0px;
}

.expand-leave-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
    padding-bottom: 0px;
}

.expand-enter,
.expand-leave-to {
    max-height: 0px;
    overflow: hidden;
    padding-top: 0px;
    padding-bottom: 0px;

}


.expand-enter-from {
    max-height: 0px;
    overflow: hidden;
}

.expand-enter-to {
    max-height: 200px;
    overflow: hidden;
    padding-bottom: 16px;
}

.expand-leave {
    max-height: 200px;
    padding-bottom: 16px;
}

.expand-leave-from {
    max-height: 200px;
    padding-bottom: 16px;
}



.expand-login-enter-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
}

.expand-login-leave-active {
    transition: all 0.5s cubic-bezier(1, 0.9, 0.3, 1);
    overflow: hidden;
    max-height: 0px;
}

.expand-login-enter,
.expand-login-leave-to {
    max-height: 0px;
    overflow: hidden;
    padding-top: 0px;

}


.expand-login-enter-from {
    max-height: 0px;
    overflow: hidden;
}

.expand-login-enter-to {
    max-height: 200px;
    overflow: hidden;
}

.expand-login-leave {
    max-height: 200px;
}

.expand-login-leave-from {
    max-height: 200px;
}
</style>